/*------------------------------------------------------------------------

$Workfile:   rot13.c  $

$Header:   T:/sc/addin/rot13/rot13.c_v   1.2   13 Jul 1998 17:57:16   BEI  $

Description:    StarCalc Add-In Example ROT13

(c) Copyright 1998 - 2000, Star Division GmbH, Hamburg


------------------------------------------------------------------------*/
static char rot13_Id[]="@(#) rot13 StarCalc ROT13 Add-In (c) 1998-2000 STAR DIVISION GmbH, Hamburg";

#include <string.h>
#include <addin.h>
#include <stdio.h>


/**
 * Defines for which Language the Addin is compiled.
 * At the momment only english and german are provided for the example.
 *
 * 49 -> german
 * everything else (default) -> english
 *
 */
#ifndef LANGUAGE
#define LANGUAGE 01
#endif

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
void CALLTYPE GetFunctionCount( USHORT *nCount )
{
    *nCount = 1;
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
void CALLTYPE GetFunctionData( USHORT *    nNo,
			       char *      pFuncName,
			       USHORT *    nParamCount,
			       ParamType * peType,
			       char *      pInternalName )
{

    switch( *nNo ) {
	case 0:
	    strcpy( pInternalName, "Rot13" );
	    strcpy( pFuncName,     "Rot13" );
	    peType[0] = PTR_STRING;
	    peType[1] = PTR_STRING;
	    *nParamCount=2;
	    break;
	 default:
	    *nParamCount    = 0;
	    *pFuncName     = 0;
	    *pInternalName = 0;
	    break;
    }
}

/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
void CALLTYPE GetParameterDescription( USHORT* nNo, USHORT* nParam,
char* pName, char* pDesc )
{
	*pName = 0;
	*pDesc = 0;


	switch ( *nNo ) {
	case 0:
		switch ( *nParam ) {
		case 0:
#if LANGUAGE == 49
			strcpy(pDesc,"ROT13 Algorithmus, jedes alphabetische Zeichen des Textes wird um 13 im Alphabet rotiert.");
#else
			strcpy(pDesc,"ROT13 Algorithm, each alphabetical character of the text is rotated by 13 in the alphabet");
#endif
			break;
		case 1:
#if LANGUAGE == 49
			strcpy(pName,"Text");
			strcpy(pDesc,"Der Text der rotiert werden soll");
#else
			strcpy(pName,"Text");
			strcpy(pDesc,"the text which should be rotated");
#endif
		}
	}
}


/*-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=*/
void CALLTYPE Rot13(char *ret, char *src)
{
    if ( ! ret ) return;
    if ( ! src ) *ret='\0';

    for(;src && *src; src++ , ret++) {
	*ret=*src;
	if (*ret >= 'A' && *ret <= 'Z') {
	    if ( (*ret +=13) > 'Z' ) *ret-=26;
	} else if (*ret >= 'a' && *ret < 'n') {
	    *ret +=13;
	} else if (*ret >= 'n' && *ret <= 'z') {
	    *ret -=13;
	}
    }
    *ret=*src;
}


/*------------------------------------------------------------------------

$Log:   T:/sc/addin/rot13/rot13.c_v  $
   
      Rev 1.2   13 Jul 1998 17:57:16   BEI
   2 Languages
   
      Rev 1.1   09 Jul 1998 09:00:50   TRI
   keine C++ Kommentar in C Files

      Rev 1.0   07 Jul 1998 20:36:36   NN
   Initial revision.

------------------------------------------------------------------------*/


